EDIT - feature request #8673

Allow OriginalSource to link to other CDM objects
11/09/2019 12:33 PM - Andreas Muller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: Release 5.11

Severity: critical

Description

Currently links are only available to Reference and (external) URIs. However, especially for adding sources to aggregated data it is a
requirement to also link to other CDM objects such as (Specimen- or Taxon-) Descriptions.

The problem is that adding a link to each Cdm Object will make the class very large. A solution might be to use the same principle as
for IntextReferences (#4719), having an in-between class "CdmLink" which allows links to a number of CdmBase classes and which
is referred from OriginalSource. It could be even merged with the IntextReference implementation.

Related issues:

Related to EDIT - feature request #4719: [MASTER] Implement IntextReference New
Related to EDIT - feature request #8686: Support CdmLink sources in bibliography Closed
Related to EDIT - feature request #8724: Allow OriginalSource to link to Taxon Closed
Related to EDIT - bug #9801: Orphan removal does not work correctly for CdmlLi... New

Associated revisions

Revision 93ad7e54 - 11/09/2019 05:41 PM - Andreas Miiller
fix #8673 Add CdmLinkSource to OriginalSourceBase

Revision 5e7c747f - 11/09/2019 05:54 PM - Andreas Miiller
fix #8673 update TaxEditor test DB to CdmLinkSource changes

Revision ade857dd - 11/09/2019 05:55 PM - Andreas Miiller
fix #8673 update Vaadin test DB to CdmLinkSource changes

Revision 186¢f7ed - 11/10/2019 12:30 PM - Andreas Miiller

ref #8673 add Cascade.Delete and orphanRemoval and handle getter/setter on target directly

Revision c1217ecf - 11/11/2019 12:12 PM - Andreas Miiller
ref #8673 Fix NPE for OriginalSourceBase.getCdmSource

Revision c32e83c4 - 11/13/2019 10:30 AM - Patrick Plitzner
ref #8673 Extend property path for CdmSources

Revision 065e965b - 11/13/2019 10:42 AM - Patrick Plitzner
ref #8673 Adapt portal to CdmSource for aggregation clones

Revision 1e2fd81a - 11/13/2019 11:15 AM - Andreas Miiller

ref #8673 make cdmSource Eager to avoid LIEs

Revision 453261d0 - 11/13/2019 11:17 AM - Patrick Plitzner
ref #8673 Extend property path for CdmSources

Revision 67ab92f3 - 11/13/2019 12:22 PM - Patrick Plitzner
ref #8673 Adapt portal to CdmSource eager loading
Revision 019036d1 - 11/13/2019 03:19 PM - Andreas Kohlbecker

ref #8673 CdmLinkSourceBeanProsessor to serialize CdmLinkSource as TypedEntityReference

Revision 628¢6976 - 11/13/2019 04:31 PM - Andreas Kohlbecker

ref #8673 CdmLinkSourceBeanProsessor to serialize CdmLinkSource as TypedEntityReference

Revision 2412e7b6 - 11/13/2019 05:16 PM - Andreas Kohlbecker

ref #8673 CdmLinkSourceBeanProsessor proper null handling

Revision 79e61daa - 11/14/2019 07:46 AM - Patrick Plitzner
ref #8673 Adapt more specific description type

Revision 4e506608 - 11/14/2019 07:54 AM - Patrick Plitzner
ref #8673 Fix description title display on taxon page

Revision f6a63f8b - 11/14/2019 11:37 AM - Andreas Kohlbecker

ref #8673 CdmLinkSourceBeanProsessor disabled and init strategy for cdmSource.target

Revision f31fdd6b - 11/14/2019 02:00 PM - Patrick Plitzner
ref #8673 Fix description title display on taxon page

Revision b6f0e806 - 11/21/2019 10:46 AM - Andreas Kohlbecker
ref #8673 extend initstrategy by cdmSource for ref #8686

History

#1 - 11/09/2019 05:43 PM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|93ad7e545dc77e63b68e434c62c8560a68bbodfb.

#2-11/11/2019 01:58 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Patrick Plitzner

Can you please review?

Please also have in mind that webservices should not deliver the full cdmobject and maybe even not the CdmLinkSource object at all but only the
OriginalSourceBase.cdmSource attribute formatted as TypedEntity(?). Maybe we can implement this within this ticket. Otherwise open new one.

#3 - 11/11/2019 11:33 PM - Andreas Miiller
- Related to feature request #4719: [MASTER] Implement IntextReference added

#4 - 11/13/2019 12:49 PM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Andreas Kohlbecker

#5 - 11/13/2019 12:50 PM - Andreas Miuller

We still need to check if the empty constructor of CdmLinkSource also could be protected. Patrick could you do this?

#6 - 11/13/2019 03:20 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Patrick Plitzner

CdmLinkSourceBeanProsessor implemented but cannot test since i can't find data with CdmLinkSource

@Patrick: please review

#7 - 11/14/2019 04:59 PM - Patrick Plitzner

- Status changed from Resolved to Closed
- Assignee changed from Patrick Plitzner to Andreas Miiller

- % Done changed from 50 to 100

works as expected

#8 - 11/15/2019 10:14 PM - Andreas Miiller
- Related to feature request #8686: Support CdmLink sources in bibliography added

#9 - 11/27/2019 02:25 PM - Andreas Miiller
- Related to feature request #8724: Allow OriginalSource to link to Taxon added

#10 - 10/08/2021 09:19 PM - Andreas Miiller
- Related to bug #9801: Orphan removal does not work correctly for CdmLinkSource added
